'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

module.exports = function () {
  function Permission() {
    _classCallCheck(this, Permission);
  }

  _createClass(Permission, null, [{
    key: 'isAnyone',


    /**
     * Access to anyone.
     */
    value: function isAnyone() {
      return function () {
        return true;
      };
    }

    /**
     * Authenticate from an access token.
     */

  }, {
    key: 'isTokenized',
    value: function isTokenized() {
      return function (_ref) {
        var req = _ref.req;
        return req.auth && req.auth.id;
      };
    }

    /**
     * Authenticate a user.
     */

  }, {
    key: 'isUser',
    value: function isUser() {
      return function (_ref2) {
        var req = _ref2.req;
        return req.user;
      };
    }

    /**
     * Authenticate an owner of a resource.
     */

  }, {
    key: 'isOwner',
    value: function isOwner() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref3$field = _ref3.field,
          field = _ref3$field === undefined ? 'user' : _ref3$field;

      return function (_ref4) {
        var body = _ref4.body,
            user = _ref4.user;
        return user && body && body[field] === user.id;
      };
    }
  }]);

  return Permission;
}();