'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mongoose = require('mongoose');
var Schema = require('../schema');

module.exports = function (_Schema) {
  _inherits(TokenSchema, _Schema);

  function TokenSchema() {
    var _ref;

    _classCallCheck(this, TokenSchema);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = TokenSchema.__proto__ || Object.getPrototypeOf(TokenSchema)).call.apply(_ref, [this].concat(args)));

    _this.add({
      token: {
        type: String,
        required: true
      },
      payload: {
        type: mongoose.Schema.Types.Mixed,
        required: true
      },
      expires: {
        type: Number,
        required: true
      },
      iat: {
        type: Number,
        required: true
      },
      active: {
        type: Boolean,
        required: true,
        default: true
      }
    });
    return _this;
  }

  return TokenSchema;
}(Schema);